<!-- 选择建标申请 -->
<script lang="ts" setup name="SelectBuildStandardDialog">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { TableColumn } from '../../../../../components/NormalTable/table_interface'
const emits = defineEmits(['confirm'])
const dialogFormVisible = ref(false)
// 查询条件
const listQuery = ref({
  limit: 20,
  offset: 1,
})
// 多选选中的内容
const checkoutList = ref([])
const loadingTable = ref(false)
const list = ref([]) // 表格数据
const total = ref(0)
const columns = ref<TableColumn[]>([
  { text: '记录表编号', value: 'siteExecutiveNo', align: 'center', width: '160px' },
  { text: '记录表名称', value: 'customerName', align: 'center' },
  { text: '设备名称', value: 'deliverer', align: 'center' },
  { text: '型号', value: 'delivererTel', align: 'center' },
  { text: '生产厂家', value: 'customerAddress', align: 'center' },
  { text: '到货时间', value: 'executiveItem', align: 'center' },
  { text: '验收人', value: 'directorName', align: 'center' },
  { text: '验收时间', value: 'applyTime', align: 'center', width: '180px' },
])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  // 模拟数据
  // getFieldTestApproveList(listQuery.value).then((response) => {
  // list.value = response.data.rows
  // total.value = parseInt(response.data.total)
  // loadingTable.value = false
  // })
}
// 重置
const clearList = () => {
  // listQuery.value = {
  //   approvalStatus: '4', // 申请状态 4已通过
  //   customerName: '', // 委托方名称
  //   directorName: '', // 负责人
  //   formId: SCHEDULE.BUSINESS_FIELDTEST_APPROVE, // 表单id
  //   siteExecutiveNo: '', // 现场检测编号
  //   limit: 20,
  //   offset: 1,
  // }
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选择现场检测编号')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  clearList()
}
// 初始化
const initDialog = () => {
  dialogFormVisible.value = true
  fetchData()
}
defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择建标申请" width="65%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="clearList">
      <!-- <search-item>
        <el-input v-model.trim="listQuery.siteExecutiveNo" placeholder="现场检测编号" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.customerName" placeholder="委托方名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.directorName" placeholder="负责人" class="short-input" clearable />
      </search-item> -->
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        is-showmulti-select
        :list-loading="loadingTable"
        :is-multi="false"
        :height="260"
        :page-sizes="[20]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
